#!/bin/bash
#  This script is part of Numdiff
#  Copyright (C)  2005-2013    Ivano Primi  <ivprimi@libero.it>    
#
#  Copying and distribution of this file, with or without modification,
#  are permitted in any medium without royalty provided the copyright
#  notice and this notice are preserved.

LESS=$1
DIFF=$2
NUMDIFF=$3

$NUMDIFF -f -z 2- file1 file3 > ./output/result13
$NUMDIFF -f -z 2- file2 file3 > ./output/result23
$NUMDIFF -f -z 2- file3 file1 > ./output/result31
$NUMDIFF -f -z 2- file3 file2 > ./output/result32
$NUMDIFF -f -z 2- file1 file4 > ./output/result14
$NUMDIFF -f -z 2- file2 file4 > ./output/result24
$NUMDIFF -f -z 2- file4 file1 > ./output/result41
$NUMDIFF -f -z 2- file4 file2 > ./output/result42
$NUMDIFF -f -z 2- file1 file5 > ./output/result15
$NUMDIFF -f -z 2- file2 file5 > ./output/result25
$NUMDIFF -f -z 2- file5 file1 > ./output/result51
$NUMDIFF -f -z 2- file5 file2 > ./output/result52
$NUMDIFF -f -z 2- file1 file6 > ./output/result16
$NUMDIFF -f -z 2- file2 file6 > ./output/result26
$NUMDIFF -f -z 2- file6 file1 > ./output/result61
$NUMDIFF -f -z 2- file6 file2 > ./output/result62
$NUMDIFF -O -z 2- file1 file3 > ./output/Oresult13
$NUMDIFF -O -z 2- file2 file3 > ./output/Oresult23
$NUMDIFF -O -z 2- file3 file1 > ./output/Oresult31
$NUMDIFF -O -z 2- file3 file2 > ./output/Oresult32
$NUMDIFF -O -z 2- file1 file4 > ./output/Oresult14
$NUMDIFF -O -z 2- file2 file4 > ./output/Oresult24
$NUMDIFF -O -z 2- file4 file1 > ./output/Oresult41
$NUMDIFF -O -z 2- file4 file2 > ./output/Oresult42
$NUMDIFF -O -z 2- file1 file5 > ./output/Oresult15
$NUMDIFF -O -z 2- file2 file5 > ./output/Oresult25
$NUMDIFF -O -z 2- file5 file1 > ./output/Oresult51
$NUMDIFF -O -z 2- file5 file2 > ./output/Oresult52
$NUMDIFF -O -z 2- file1 file6 > ./output/Oresult16
$NUMDIFF -O -z 2- file2 file6 > ./output/Oresult26
$NUMDIFF -O -z 2- file6 file1 > ./output/Oresult61
$NUMDIFF -O -z 2- file6 file2 > ./output/Oresult62
$NUMDIFF -V -z 2- file1 file3 > ./output/Vresult13
$NUMDIFF -V -z 2- file2 file3 > ./output/Vresult23
$NUMDIFF -V -z 2- file3 file1 > ./output/Vresult31
$NUMDIFF -V -z 2- file3 file2 > ./output/Vresult32
$NUMDIFF -V -z 2- file1 file4 > ./output/Vresult14
$NUMDIFF -V -z 2- file2 file4 > ./output/Vresult24
$NUMDIFF -V -z 2- file4 file1 > ./output/Vresult41
$NUMDIFF -V -z 2- file4 file2 > ./output/Vresult42
$NUMDIFF -V -z 2- file1 file5 > ./output/Vresult15
$NUMDIFF -V -z 2- file2 file5 > ./output/Vresult25
$NUMDIFF -V -z 2- file5 file1 > ./output/Vresult51
$NUMDIFF -V -z 2- file5 file2 > ./output/Vresult52
$NUMDIFF -V -z 2- file1 file6 > ./output/Vresult16
$NUMDIFF -V -z 2- file2 file6 > ./output/Vresult26
$NUMDIFF -V -z 2- file6 file1 > ./output/Vresult61
$NUMDIFF -V -z 2- file6 file2 > ./output/Vresult62
$NUMDIFF -z 2- file2 file7 > ./output/result27
$NUMDIFF -f -z 2- file2 file7 > ./output/fresult27
$NUMDIFF -O -z 2- file2 file7 > ./output/Oresult27
$NUMDIFF -z 2- file8 file2 > ./output/result82
$NUMDIFF -f -z 2- file8 file2 > ./output/fresult82
$NUMDIFF -O -z 2- file8 file2 > ./output/Oresult82

LIST="fresult27 fresult82 Oresult13 Oresult14 Oresult15 Oresult16 Oresult23 Oresult24 Oresult25 Oresult26 Oresult27 Oresult31 Oresult32 Oresult41 Oresult42 Oresult51 Oresult52 Oresult61 Oresult62 Oresult82 result13 result14 result15 result16 result23 result24 result25 result26 result27 result31 result32 result41 result42 result51 result52 result61 result62 result82 Vresult13 Vresult14 Vresult15 Vresult16 Vresult23 Vresult24 Vresult25 Vresult26 Vresult31 Vresult32 Vresult41 Vresult42 Vresult51 Vresult52 Vresult61 Vresult62"

for NAME in $LIST; do
    $DIFF $NAME ./output/$NAME > ./output/comparison
    if [ $? -ne 0 ]; then
	$LESS ./output/comparison
	echo -e "$NAME and ./output/$NAME \t differ \t\t [ ERR ]"
    else
    	echo -e "$NAME and ./output/$NAME \t are equal \t\t [ OK ]"	
    fi
done

echo "Removing output files..."
rm ./output/*
echo "Done !"
